local GW, GH = love.graphics.getDimensions()
local GOX, GOY = GW/2, GH/2

local backgroundImage = love.graphics.newImage("background.jpg")
backgroundImage:setWrap("repeat", "repeat") -- Always important to call this method

local backgroundAngle = 0

-- Set a distance larger than the screen size for the vertices of the mesh
local distance = 2 * math.max(GW, GH)

-- Create an array for the texture coordinates of the mesh
-- To repeat the texture it is necessary to normalize from 0 to 1 by dividing the size of the mesh by the size of the texture
-- If we defined the corners only with 0 and 1 the texture would simply be stretched.
local meshVertices = {
    {-distance, -distance, 0, 0},
    {distance, -distance, GW / backgroundImage:getWidth(), 0},
    {distance, distance, GW / backgroundImage:getWidth(), GH / backgroundImage:getHeight()},
    {-distance, distance, 0, GH / backgroundImage:getHeight()}
}

-- Create a mesh from the array
local mesh = love.graphics.newMesh(meshVertices, "fan")
mesh:setTexture(backgroundImage)



-- We do it all --

function love.update(dt)
    backgroundAngle = backgroundAngle + dt
end

function love.draw()
  love.graphics.setColor(1, 1, 1)
  love.graphics.draw(mesh, GOX, GOY, backgroundAngle, 1, 1, GOX, GOY)
end
